PTHREAD_SETSPECIFIC(3)

NAME
pthread_setspecific - set a thread-specific data value

SYNOPSIS
#include <pthread.h>
int
pthread_setspecific(pthread_key_t key, const void *value);

DESCRIPTION
The pthread_setspecific() function associates a thread-specific value with a key obtained via a previous call to pthread_key_create(). Different threads may bind different values to the same key. These values are typically pointers to blocks of dynamically allocated memory that have been reserved for use by the calling thread.

The effect of calling pthread_setspecific() with a key value not obtained from pthread_key_create(), or after key has been deleted with pthread_key_delete(), is undefined.

pthread_setspecific() may be called from a thread-specific data destructor function; however, this may result in lost storage or infinite loops.

RETURN VALUES
If successful, the pthread_setspecific() function will return zero. Otherwise, an error number will be returned to indicate the error.

ERRORS
pthread_setspecific() will fail if:

[EINVAL]
    The key value is invalid.

[ENOMEM]
    Insufficient memory exists to associate the value with the key.

SEE ALSO
pthread_getspecific(3), pthread_key_create(3), pthread_key_delete(3)

STANDARDS
pthread_setspecific() conforms to p1003.1-96.